main.code<-function(n.reps, init.comp, init.dist, n.property.sides.init, target, n.habs, p.deforest, alpha, Beta, res, res.sides,
                    profit.corr, phi)
{
  ben.changes<-prod.changes<-prod.prop.changes<-rep(NA,n.reps)
  indiv.ben.changes<-indiv.prod.changes<-indiv.prod.prop.changes<-rep(NA,n.reps)
  indiv.median.csize.changes<-indiv.mean.csize.changes<-indiv.min.csize.changes<-indiv.max.csize.changes<-indiv.cnum.changes<-rep(NA,n.reps)
  indiv.ea.changes<-indiv.mean.dist.to.edge.changes<-indiv.min.hab.rep.changes<-rep(NA,n.reps)
  rep.ctr<-1
  test.start<-proc.time()
  wctr<-0
  wctr1<-0
  while (rep.ctr<=n.reps&&(wctr1<5000))
  {
    wctr1<-wctr1+1
    if (rep.ctr%%50==0){print(rep.ctr)}
    n.property.sides<-n.property.sides.init
    
    ####################################
    ### Generate initial landscape
    ####################################
    n.properties<-n.property.sides^2
    n.sides<-n.property.sides*2
    n.parcels<-n.sides*n.sides
    res.coord1<-res.coord2<-NA
    if (res==1)
    {
      n.property.sides<-n.property.sides+res.sides
      n.properties<-n.property.sides^2
      n.sides<-n.property.sides*2
      n.parcels.sml<-n.sides*n.sides-(2*res.sides)^2
      n.parcels<-n.sides*n.sides
      res.coord1<-floor((n.sides-res.sides*2)/2)
      res.coord2<-floor((n.sides-res.sides*2)/2+res.sides*2)
    }

    ###################
    # ag profit landscape
    ###################
    simgrid <- expand.grid(1:n.sides, 1:n.sides)
    n <- nrow(simgrid)
    # Set up distance matrix
    distance <- as.matrix(dist(simgrid))
    # Generate random variable
    X <- rmvn(1, rep(0, n), exp(-phi * distance))
    require(raster)
    Xraster <- rasterFromXYZ(cbind(simgrid[, 1:2] - 0.5, X))
    ag.prod<-as.matrix(Xraster)
    ag.prod<-ag.prod+abs(min(ag.prod))

    ###################
    # habitat landscape
    ###################
    if (n.habs>1)
    {
      if(profit.corr==1)
      {
        habitats<-gen.habs.profit.corr(alpha, Beta, n.parcels, n.habs, ag.prod) # controllable aggregation
      }else{habitats<-gen.habs(alpha, Beta, n.parcels, n.habs)} # controllable aggregation}
    }else{habitats<-rep(1,n.sides^2)}
    dim(habitats) <- c(n.sides,n.sides)

    ###################
    # initial land-cover landscape
    ###################
    # Conserved?
    conserved<-rep(0,n.parcels)
    dim(conserved)<-c(n.sides,n.sides)
    if (init.dist=="rand")
    {
      # completely random:
      conserved[sample(1:(n.parcels), round(init.comp*n.parcels), FALSE)]<-1
    }else if (init.dist=="split"){
      # all in a clumped strip
      conserved[,1:(round(n.sides*init.comp))]<-1
    }else if (init.dist=="local"){
      # first: randomly distribute conversion through landscape -- this will signify
      # how much of each property is converted -- does not signify conversion in itself
      conserved[sample(1:(n.parcels), round(init.comp*n.parcels), FALSE)]<-1
      # Second: according to compliance, most profitable parcels 
      # are converted on each property
      for (prop.ctr in 1:n.properties) 
      {
        # describe property by top left-hand corner
        property.coords<-index.to.coords(prop.ctr,n.property.sides)
        prop.x<-property.coords[1,1]*2-1
        prop.y<-property.coords[1,2]*2-1
        property<-expand.grid((0:1)+prop.x, (0:1)+prop.y)
        num.conv<-4-sum(conserved[0:1+prop.x,0:1+prop.y])
        conserved[0:1+prop.x,0:1+prop.y]<-rep(1,4)
        profits<-sort(ag.prod[0:1+prop.x,0:1+prop.y], decreasing=T)
        if (num.conv>0)
        {
          for (ctr in 1:num.conv)
          {
            conserved[which(ag.prod==profits[ctr])]<-0
          }
        }
      }
    }else if (init.dist=="regional")
    {
      profits<-sort(ag.prod, decreasing=T)
      conserved[-which(ag.prod%in%profits[1:round((1-init.comp)*length(profits))])]<-1
    }
    reserve<-rep(0,n.parcels)
    dim(reserve)<-c(n.sides,n.sides)
    locked.in<-rep(0,n.parcels)
    dim(locked.in)<-c(n.sides,n.sides)
    if (res==1)
    {
      conserved[res.coord1:res.coord2, res.coord1:res.coord2]<-1
      ag.prod[res.coord1:res.coord2,res.coord1:res.coord2]<-0
      reserve[res.coord1:res.coord2, res.coord1:res.coord2]<-1
      locked.in[res.coord1:res.coord2, res.coord1:res.coord2]<-1
    }
    agriculture<-matrix(1,n.sides,n.sides)-conserved
    tot.ag.prof<-sum(sum(ag.prod*agriculture)) 
    
    ###################################
    ### Predict individual compliance
    ###################################
    indiv.comp.cons<-conserved
    avail.ag.prod<-ag.prod*(1-indiv.comp.cons); avail.ag.prod[which(avail.ag.prod==0)]<-NA
    temp.ag.prod<-ag.prod*indiv.comp.cons; temp.ag.prod[which(temp.ag.prod==0)]<-NA
    for (prop.ctr in 1:n.properties)
    {
      property.coords<-index.to.coords(prop.ctr,n.property.sides)
      prop.x<-property.coords[1,1]*2-1
      prop.y<-property.coords[1,2]*2-1
      property<-expand.grid((0:1)+prop.x, (0:1)+prop.y)
      prop.cons<-mean(conserved[0:1+prop.x,0:1+prop.y])
      orig.cons<-prop.cons
      reserved<-any(reserve[0:1+prop.x,0:1+prop.y]==1)
      if (reserved==FALSE)
      {
        wctr<-0
        while (prop.cons<target&&(wctr<5000)) # undercompliant property
        {
          indiv.comp.cons[which(avail.ag.prod==min(avail.ag.prod[0:1+prop.x,0:1+prop.y], na.rm=T))]<-1
          prop.cons<-mean(indiv.comp.cons[0:1+prop.x,0:1+prop.y])
          avail.ag.prod<-ag.prod*(1-indiv.comp.cons); avail.ag.prod[which(avail.ag.prod==0)]<-NA
          wctr<-wctr+1
        }
        wctr<-0
        while (prop.cons>target&&(wctr<5000)) #overcompliant property
        {
          indiv.comp.cons[which(temp.ag.prod==max(temp.ag.prod[0:1+prop.x,0:1+prop.y], na.rm=T))]<-0#rbinom(length(which(temp.ag.prod==max(temp.ag.prod[0:1+prop.x,0:1+prop.y], na.rm=T))),1,(1-p.deforest))
          prop.cons<-mean(indiv.comp.cons[0:1+prop.x,0:1+prop.y])
          temp.ag.prod<-ag.prod*(indiv.comp.cons); temp.ag.prod[which(temp.ag.prod==0)]<-NA
          wctr<-wctr+1
        }
        if (orig.cons>target)
        {
          # hot air trades -- probabilistic deforestation p.deforest
          deforested.prop<-(conserved[0:1+prop.x,0:1+prop.y]-indiv.comp.cons[0:1+prop.x,0:1+prop.y])
          new.prop<-conserved[0:1+prop.x,0:1+prop.y];
          new.prop[which(deforested.prop==1)]<-rbinom(length(which(deforested.prop==1)),1,(1-p.deforest))
          indiv.comp.cons[0:1+prop.x,0:1+prop.y]<-new.prop
        }
      }
    }
    
    ####################################
    ### Lock untradeable parcels in
    ####################################
    temp<-lock.in(conserved,ag.prod, target, locked.in) 
    to.allocate<-temp$to.allocate;allocated<-temp$allocated;ill.all<-temp$ill.all
    under.profit<-temp$under.profit;over.profit<-temp$over.profit;n.allowable.trades<-temp$n.allowable.trades
    locked.in<-temp$locked.in
   
    ####################################
    ### Trade -- classic market mechanism
    ####################################
    reforest<-clearag<-array(NA,dim=c(n.sides, n.sides))
    temp<-run.market.new(conserved, under.profit, over.profit, ag.prod,ill.all,clearag,reforest,n.allowable.trades, p.deforest) 
    conserved.new<-temp$conserved.new; ill.all<-temp$ill.all; 
    reforest<-temp$reforest; clearag<-temp$clearag; trade<-temp$trade

    ##########################
    # assessing outcomes
    ##########################
    indiv.comp.agriculture<-matrix(1,n.sides,n.sides)-indiv.comp.cons
    indiv.ag.prod<-sum(ag.prod*indiv.comp.agriculture)
    total.ag.prod<-sum(ag.prod*(1-conserved.new))    
    n.habs.cons<-rep(NA,n.habs)
    habs.cons<-nearest.edge<-indiv.habs.cons<-habs.cons.new<-array(NA,dim=c(n.sides,n.sides,n.habs))
    for (h in 1:n.habs)
    {
      n.habs.cons[h]<-sum(habitats*conserved==h)
      habs.cons[,,h]<-(habitats*conserved==h)-0
      indiv.habs.cons[,,h]<-(habitats*indiv.comp.cons==h)-0
      habs.cons.new[,,h]<-(habitats*conserved.new==h)-0
    }
    temp<-find.changes(indiv.habs.cons, indiv.comp.cons, habs.cons.new, conserved.new, ag.prod, n.habs, n.property.sides)
    ### change in benefit:
    indiv.ben.changes[rep.ctr]<-temp$PC.change
    indiv.prod.changes[rep.ctr]<-temp$prod.change
    indiv.prod.prop.changes[rep.ctr]<-temp$prod.prop.change
    indiv.mean.csize.changes[rep.ctr]<-temp$mean.csize.change
    indiv.min.csize.changes[rep.ctr]<-temp$min.csize.change
    indiv.max.csize.changes[rep.ctr]<-temp$max.csize.change
    indiv.cnum.changes[rep.ctr]<-temp$cnum.change
    indiv.ea.changes[rep.ctr]<-temp$ea.change
    indiv.median.csize.changes[rep.ctr]<-temp$median.csize.change
    indiv.mean.dist.to.edge.changes[rep.ctr]<-temp$mean.dist.to.edge.change
    indiv.min.hab.rep.changes[rep.ctr]<-temp$min.hab.rep.change
    
    rep.ctr<-rep.ctr+1
    test.stop<-proc.time()-test.start
  }
  return(list(ben.changes=ben.changes,prod.changes=prod.changes,prod.prop.changes=prod.prop.changes,
              indiv.ben.changes=indiv.ben.changes, indiv.prod.changes=indiv.prod.changes, 
              indiv.prod.prop.changes=indiv.prod.prop.changes, indiv.mean.csize.changes=indiv.mean.csize.changes,
              indiv.min.csize.changes=indiv.min.csize.changes, indiv.max.csize.changes=indiv.max.csize.changes,
              indiv.cnum.changes=indiv.cnum.changes, indiv.ea.changes=indiv.ea.changes,indiv.median.csize.changes=indiv.median.csize.changes,
              indiv.mean.dist.to.edge.changes=indiv.mean.dist.to.edge.changes, indiv.min.hab.rep.changes=indiv.min.hab.rep.changes))
}
